#!/usr/bin/python

import sys, socket, math, traceback, random
from igralec import *
from polje import *

class Socket:
	__slots__ = ["sock", "buf"]
	
	def __init__(self): self.sock = None; self.buf = ""
	def connect(self, hostName, port):
		try:
			self.sock = socket.socket(socket.AF_INET)
			self.sock.connect((hostName, port))
		except: raise Exception("Prijava na streznik neuspesna")
		self.buf = ""
		server = self.readline()
		print "%s" % server
		self.writeline("AVE %s" % (Igralec.ime))
		succ = self.readline()
		if succ != "PRIJAVA USPESNA": raise Exception("Prijava na streznik neuspesna: %s" % succ)
	def close(self):
		if self.sock: self.sock.close()
	def readline(self):
		while True:
			i = self.buf.find('\n')
			if i >= 0: 
				line = self.buf[:i].strip()
				self.buf = self.buf[i + 1:]
				return line
			try: s = self.sock.recv(1024)
			except: raise Exception("Napaka pri komunikaciji s streznikom")
			if not s: raise Exception("Streznik je zaprl povezavo")
			self.buf += s
	def writeline(self, line): self.sock.send(line + "\n")
	def event_loop(self):
		cmda = self.readline().split()
		if cmda[0] == "ADIJO": return False
		if cmda[0] == "KONEC_IGRE": return True
		if cmda[0] != "ZBUDI_SE": raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		
		w,h,z = [int(x) for x in cmda[1:4]]
		igralno_polje = Polje(sirina=w, visina=h)
		
		t = Igralec()
		t.ZbudiSe(w, h, z==0)
		
		self.writeline("BUDEN")
		
		while True:
			cmda = self.readline().split()
			if cmda[0] == "ADIJO": return False
			elif cmda[0] == "KONEC_IGRE":
				t.KonecIgre(int(cmda[1])); break
			elif cmda[0] == "QV":
				prejsnja_poteza = int(cmda[1])
				igralno_polje.dodaj(prejsnja_poteza, barvaNasprotnik)
				stolpec = t.KamGres(Polje(orig=igralno_polje), prejsnja_poteza)
				igralno_polje.dodaj(stolpec, barvaJaz)
				self.writeline("QVR %d" % (stolpec))
			else: raise Exception("Napaka pri komunikaciji s streznikom: %s" % cmda[0])
		return True

if len(sys.argv) > 1: hostName = sys.argv[1]
else: hostName = "localhost"

try:
	sock = Socket()
	sock.connect(hostName, 1177)
	random.seed()
	while sock.event_loop(): pass
	sock.close()
except:
	traceback.print_exc()
