import copy

barvaPrazna = 0
barvaNasprotnik = -1
barvaJaz = 1

# Podatkovni tip Polje -- igralno polje za igro "4 v vrsto"
#
# uporaba:
#  p = Polje(sirina=13, visina=17)             -- naredi novo polje dimenzij 13x17
#  q = Polje(orig = p)                                  -- naredi novo polje, katerega dimenzije in barve celic so enake polju p
#
#  p.izpisi();                                                -- izpise polje na zaslon
#  p.dodaj(2, barvaJaz);                            -- najnizjo(!) prazno celico stolpca 2 pobarva z mojo barvo
#  b = p((1,2));                                             -- prebere barvo celice (1,2); pazi: dvojni oklepaji -- parameter je tuple (1,2)
#  p((3,4)) = barvaNasprotnik;                  -- celico (3,4) pobarva z nasprotnikovo barvo

class Polje:
	slots = ['sirina', 'visina', 'p']

	def __init__(self, sirina=None, visina=None, orig=None):
		if orig:
			self.sirina = orig.sirina
			self.visina = orig.visina
			self.p = copy.deepcopy(orig.p)
		else:
			self.sirina = sirina
			self.visina = visina
			self.p = [[ barvaPrazna ] * self.visina for x in range(self.sirina)]
	
	def __getitem__(self, pos):
		x,y = pos
		return self.p[x][y]
	
	def __setitem__(self, pos, o):
		x,y = pos
		self.p[x][y] = o
	
	def dodaj(self, stolpec, barva):
		if stolpec == -1: return
		_st = self.p[stolpec]
		kam = -1
		try:
			kam = _st.index(barvaPrazna)
		except:
			raise Exception("Stolpec ze zaseden!")
		_st[kam] = barva
	
	def izpisi(self):
		for y in range(self.visina - 1, -1, -1):
			for x in range(self.sirina):
				c = self.p[x][y]
				if c == barvaJaz: print '*',
				elif c == barvaNasprotnik: print 'o',
				else: print ' ',
			print ''
		print ''
